'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = function (ComponentStyle) {
  var createStyledComponent = function createStyledComponent(target, rules, props, parent) {
    var componentStyle = new ComponentStyle(rules);
    var ParentComponent = parent || {};

    var prevProps = target && typeof target !== 'string' ? (typeof target === 'undefined' ? 'undefined' : _typeof(target)) === 'object' ? target.props : typeof target === 'function' ? target.options.props : {} : {};
    var mergedProps = Object.assign({}, prevProps, props);

    var StyledComponent = Object.assign({}, {
      extends: ParentComponent,
      props: mergedProps,
      data: function data() {
        return {
          generatedClassName: ''
        };
      },
      render: function render(createElement) {
        return createElement(target, {
          class: [this.generatedClassName],
          props: this.$props
        }, this.$slots.default);
      },
      methods: {
        generateAndInjectStyles: function generateAndInjectStyles(componentProps) {
          return componentStyle.generateAndInjectStyles(componentProps);
        }
      },
      mounted: function mounted() {
        var componentProps = Object.assign({}, this.$props);
        this.generatedClassName = this.generateAndInjectStyles(componentProps);
      }
    });

    return StyledComponent;
  };

  return createStyledComponent;
};

module.exports = exports['default'];